#!/usr/bin/python

#	Oberflaeche fuer den
#	Fahrscheinautomaten	BICS, Bombei, 26.11.01

#	Datei: fsa_gui00.py
#       - Zum Verteilen und Bearbeiten -

import Tkinter

from fsa_model00 import *

class Rahmen(Tkinter.Frame):
   def __init__(self,mutter,wo):
    	Tkinter.Frame.__init__(self,mutter)
        self.pack(side = wo, fill = "x", expand = 1, ipady=5)

class Etikett(Tkinter.Label):
   def __init__(self,mutter,was):
    	Tkinter.Label.__init__(self,mutter)
    	self.config(text = was)
        self.pack(side = "top", fill = "x", expand = 1)	
   def neu (self,was):
    	self.config(text = was)
   def neu_farbig (self,text,fgcol,bgcol):
        self.config(text = text,fg = fgcol, bg = bgcol)
   def neu_tief (self):
    	self.config(relief = "sunken")

class AnleitungBereich(Anleitung):
    def __init__(self,mutter):
    	Anleitung.__init__(self)
        rechtermittRahmen = Rahmen(mutter,"right")
        mutterRahmen      = rechtermittRahmen
        self.bedienLabel  = Etikett(mutterRahmen,"Bedienung")
        self.bedienLabel.pack()
    	self.fsaNachricht = Tkinter.Message(mutterRahmen,
		width = 200,
		relief = "groove")
	self.fsaNachricht.pack()
    def anzeigen(self,titel):
	ganzeAnleitung = self.gib_AnleitungsText()  #Liste von Klasse "Anleitung"
	zeilenAnleitung = "leer"
	for wort in ganzeAnleitung:
	   	if zeilenAnleitung == "leer":
	   		zeilenAnleitung = wort
		else:	zeilenAnleitung = zeilenAnleitung + "\n" + wort
    	self.fsaNachricht.config(text = zeilenAnleitung)
        self.bedienLabel.neu(titel)
	
class DisplayBereich:
    def __init__(self,mutter,kassier):
	self.kassier_objekt =  kassier
        obererRahmen        =  Rahmen(mutter,"top")
        self.mutterRahmen   =  obererRahmen
    def anzeigen(self,titel):
        self.titelLabel   = Etikett(self.mutterRahmen,titel)
	self.displayLabel = Etikett(self.mutterRahmen,"")
        self.displayLabel.neu_tief()
    def aktualisieren (self,aktion):
        text,fg,bg = self.kassier_objekt.gib_aktuellen_Text(aktion)
        self.displayLabel.neu_farbig(text,fg,bg)


class AusgabeBereich:
   def __init__(self,mutter,richtung):
        self.Rahmen       = Rahmen(mutter,richtung)
        self.titelLabel   = Etikett(self.Rahmen,"")
	self.displayLabel = Etikett(self.Rahmen,"")
        self.displayLabel.neu_tief()
   def anzeigen_Ausgabe(self,titel):
        self.titelLabel.neu (titel)
   def aendern_Ausgabe(self,ltext,lfgcolor,lbgcolor):
        self.displayLabel.neu_farbig(ltext,lfgcolor,lbgcolor)
   def setze_AnklickKommando(self,kommando):
   	self.displayLabel.bind("<ButtonPress>",kommando )
   def leeren(self,ereignis):
        color = "lightgrey"
    	self.aendern_Ausgabe(" ",color,color)

class FSAusgabeBereich (AusgabeBereich):
   def __init__(self,mutter,kassier):
	AusgabeBereich.__init__(self,mutter,"bottom")
	self.aendern_Ausgabe("\n","grey","lightgrey")
	self.setze_AnklickKommando(self.entnehmen)
	self.kassier_objekt  =  kassier
	self.tk_objekt  =  mutter
   def aktualisieren(self):
    	fgcolor  = "black"
    	tarif	 = self.kassier_objekt.gib_aktuellen_Tarif()
        if tarif == "" :
                bgcolor  = "lightgrey"
                text     = ""
        else :
    	  preis	 = self.kassier_objekt.gib_aktuellen_Preis()
          text     = "Fahrschein \n %s \n %7.2f DM" % (tarif, preis)
    	  bgcolor = self.kassier_objekt.gib_Farbe_von(tarif)
    	self.aendern_Ausgabe(text,fgcolor,bgcolor)

   def entnehmen(self,ereignis):
        if self.kassier_objekt.FS_ist_entnommen():
          self.tk_objekt.quit()
        else:
          self.kassier_objekt.FS_entnehmen()
          self.leeren("<Button>")


class RueckgabeBereich (AusgabeBereich):
   def __init__(self,mutter,kassier):
	AusgabeBereich.__init__(self,mutter,"bottom")
	self.aendern_Ausgabe("\n","grey","lightgrey")
	self.setze_AnklickKommando(self.leeren)
	self.kassier_objekt  =  kassier
   	self.geld_objekt  = Geld()        # aus dem Fachkonzept
   def aktualisieren(self):
    	text	    = ""
    	fgcolor     = "black"
    	bgcolor     = "white"
    	alleMuenzen = self.kassier_objekt.gib_Rueckgeld()
    	for muenze in alleMuenzen:
    		bgcolor =  self.geld_objekt.gib_Farbe_von(muenze)
    		text    =  text + "  " + muenze + "  "
    	self.aendern_Ausgabe(text,fgcolor,bgcolor)
   	
   	

class TarifBereich:
    def __init__(self,mutter,kassier,guidisplay):
        self.linkerobererRahmen = Rahmen(mutter,"left")
        self.tarifLabel = Etikett(self.linkerobererRahmen,"Tarife")
	self.kassier_objekt     = kassier
	self.GUI_Display        = guidisplay
	self.fahrschein_objekt  = Fahrschein()        # aus dem Fachkonzept
	self.gewaehlterTarif = Tkinter.StringVar()
	alleTarife      = self.fahrschein_objekt.gib_alleTarife()
	for dieserTarif in alleTarife:
	  if ( dieserTarif <> "" ):
		self.tarifWahl = Tkinter.Radiobutton(self.linkerobererRahmen,
        		text = dieserTarif, value = dieserTarif,
			anchor = "w", variable = self.gewaehlterTarif,
			command = self.gewaehlt)
		self.tarifWahl.pack(side = "top", fill = "x")
    def anzeigen(self,titel):
        self.tarifLabel.neu(titel)
    def gewaehlt(self):
    	aktuellerTarif  = self.gewaehlterTarif.get()
	self.kassier_objekt.setze_aktuellen_Tarif(aktuellerTarif)
        self.GUI_Display.aktualisieren("zahlen")

class GeldBereich:
    def __init__(self,mutter,kassier,guidisplay,schachtobjekt,rueckobjekt):
        rechterobererRahmen = Rahmen(mutter,"top")
        rechterobererRahmen.config(relief = "ridge")
        self.geldLabel = Etikett(rechterobererRahmen,"hier Geld")
	self.kassier_objekt     = kassier
	self.GUI_Display        = guidisplay
	self.fahrschein_objekt  = Fahrschein()        # aus dem Fachkonzept
	self.geld_objekt        = Geld()              # aus dem Fachkonzept
	self.fsaSchacht      = schachtobjekt
	self.fsaRueck        = rueckobjekt
	self.geworfenesGeld  = Tkinter.StringVar()
	alleGeldstuecke      = self.geld_objekt.gib_alleGeldstuecke()
	for diesesGeld in alleGeldstuecke:
		geldWahl = Tkinter.Radiobutton(rechterobererRahmen,
			command = self.eingeworfen,
			text = diesesGeld,
                        indicatoron = 0,
			variable = self.geworfenesGeld,
			value = diesesGeld)
		geldWahl.pack(side = "left",ipadx=2,ipady=4)
    def anzeigen(self,titel):
        self.geldLabel.neu(titel)
    def eingeworfen(self):
	geworfeneMuenze  = self.geworfenesGeld.get()
	self.kassier_objekt.setze_eingeworfene_Muenze ( geworfeneMuenze )
	if  self.kassier_objekt.FS_ist_bezahlt() :
	   self.GUI_Display.aktualisieren("nehmen")
	   self.fsaSchacht.aktualisieren()
	   self.fsaRueck.aktualisieren()
	else :
	   self.GUI_Display.aktualisieren("zahlen")
	self.geworfenesGeld.set("none") #... deselektiert alle Knpfe!
