#!/usr/bin/python

#	Model (Fachkonzept) fuer den
#	Fahrscheinautomaten	BICS, Bombei, 26.11.01
#	Dateinamne: fsa_model00.py
#       - Zum Verteilen und Bearbeiten -

class Anleitung:
   def __init__(self):
    	leer = ""
	self.Anleitungstext = [	" ","whlen",
				" ","einwerfen",
				" ","entnehmen"," "]
   def gib_AnleitungsText(self):
     	return self.Anleitungstext

class Muenze:
   def __init__(self):
	self.alleGeldstuecke  = ["10 Pf", "50 Pf", "1 DM", "2 DM" ]
     	self.alleStueckwerte  = [ 0.1,      0.5,     1,     2 ]
     	self.alleStueckfarben = [ "yellow", "white","white","white" ]
   def gib_alleGeldstuecke(self):
    	return self.alleGeldstuecke

class Geld(Muenze):
   def __init__(self):
        Muenze.__init__(self)
     	self.alleGeldnamen    = self.alleGeldstuecke
     	self.alleGeldwerte    = self.alleStueckwerte
     	self.alleFarben       = self.alleStueckfarben
	self.neuerAnzeigetext = "Noch zu zahlen : "
   def gib_alleGeldwerte(self):
    	return self.alleGeldwerte

   def _wieviele_Geldnamen(self):
    	return range(0,len(self.alleGeldnamen))
   def gib_Wert_von(self,name):
	wert = 0.0
	for index  in self._wieviele_Geldnamen():
		if self.alleGeldnamen[index] == name:
			wert = self.alleGeldwerte[index]
	return wert
   def gib_Farbe_von(self,name):
	wert = "white"
	for index  in  self._wieviele_Geldnamen():
		if self.alleGeldnamen[index] == name:
			wert = self.alleFarben[index]
	return wert

   def gib_Stueckelung(self,rueckgeld):
        restrueckgeld=abs(rueckgeld+0.02)
        rueckliste = []
        alleMuenznamen = self.alleGeldstuecke[:]
	alleMuenznamen.reverse()
        for aktuellerMuenzname in alleMuenznamen:
	  aktuellerMuenzwert= self.gib_Wert_von(aktuellerMuenzname)
          while aktuellerMuenzwert <= restrueckgeld:
            rueckliste.append(aktuellerMuenzname)
            restrueckgeld=restrueckgeld-aktuellerMuenzwert
        return rueckliste


class Fahrschein:
    def __init__(self):
	self.alleTarife = ["", "Erwachsener", "Kind",   "Umwelt Premium"]
     	self.allePreise = [0,   4 ,            2.7 ,     120 ]
	self.alleFarben = ["", "white",       "yellow", "magenta"]
    def gib_allePreise(self):
    	return self.allePreise
    def gib_alleTarife(self):
    	return self.alleTarife
    def _wieviele_Fahrscheine(self):
    	return range(0,len(self.alleTarife))
    def gib_Preis_von(self,name):
	wert = 0.0
	for index  in self._wieviele_Fahrscheine() :
		if self.alleTarife[index] == name:
			wert = self.allePreise[index]
	return wert

    def gib_Farbe_von(self,name):
	wert = "white"
	for index  in  self._wieviele_Fahrscheine():
		if self.alleTarife[index] == name:
			wert = self.alleFarben[index]
	return wert


class Anzeige:
   def __init__(self):
    	leer = ""
    	text = "Bitte whlen Sie ein Produkt!"
    	null = 0.0
        self.anzeige_text = { "leer" : ("","white","red"),
                "hallo"  : ("Willkommen zum Verkaufsautomaten!","black","grey"),
                "whlen" : ("Bitte whlen Sie ein Produkt!","white","black"),
                "zahlen" : ("Noch zu zahlen: ","black","lightgreen"),
                "nehmen" : ("Bitte Fahrschein entnehmen!!","white","blue"),
                "leeren" : ("Bitte Restgeld entnehmen!!","blue","white") }
   def setze_AnzeigeText(self,thema,wert=0.0):
     if (thema=="zahlen") and (wert > 0.0):
     	Anzeige = "Noch zu zahlen: %7.2f DM" % wert
        self.anzeige_text["zahlen"] = (Anzeige,"black","lightgreen")
     elif (thema=="leeren") and (wert > 0.0):
     	Anzeige = "Restgeld nehmen: %7.2f DM" % wert
        self.anzeige_text["leeren"] = (Anzeige,"blue","white")
     else :
        self.anzeige_text["zahlen"] = ("Falsche Text-Anforderung ('zahlen'?)","white","red")
        self.anzeige_text["leeren"] = ("Falsche Text-Anforderung ('leeren'?)","white","red")

   def gib_AnzeigeText(self,thema):
        text = "Falsche Text-Anforderung (Thema: %s)" % thema
        text = (text,"white","red")
    	return self.anzeige_text.get(thema,text)


class Kassierer:
   def __init__(self):
   	self.geldobjekt = Geld()
   	self.fsobjekt = Fahrschein()
   	self.anzeigeobjekt = Anzeige()
	self._initialisieren()

   def gib_aktuellen_Tarif (self):
    	return self.aktuellerTarif
   def gib_aktuellen_Preis (self):
    	return self.aktuellerPreis
   def setze_Rueckgeld (self,liste):
	self.Rueckgeld      = liste[:]
   def setze_zu_zahlende_Summe(self,preis):
        self.zzSumme = preis
   def setze_bezahlte_Summe(self,preis):
        self.bezSumme = preis
   def _initialisieren (self):
    	null = 0.0
    	self.zzSumme = null   #zu zahlende Summe
        self.bezSumme = null  #bezahlte Summe
	self.aktuellerTarif = ""
	self.aktuellerPreis = null
	self.Rueckgeld      = []
	self.eingeworfene_Muenze  =  ""
	self.Fahrschein_entnommen =  "wahr"
	self.Rueckgeld_entnommen  =  "wahr"

   def _vermindere_zu_zahlende_Summe (self,minuend):
    	self.zzSumme = self.zzSumme - minuend
   def _erhoehe_bezahlte_Summe (self,summand):
        self.bezSumme = self.bezSumme + summand
   def gib_bezahlte_Summe(self):
        return self.bezSumme
   def gib_zu_zahlende_Summe(self):
        return self.zzSumme
   def gib_Rueckgeld(self):
        return self.Rueckgeld
   def FS_ist_bezahlt(self):
   	return  (self.zzSumme <= 0)
   def FS_ist_entnommen(self):
   	return  (self.Fahrschein_entnommen ==  "wahr")
   def FS_entnehmen (self):
	self._initialisieren()

   def gib_Farbe_von(self,name):
	return self.fsobjekt.gib_Farbe_von(name)
   def gib_aktuellen_Text(self,name):
	return self.anzeigeobjekt.gib_AnzeigeText(name)

   def setze_aktuellen_Tarif(self,tarif):
	self.aktuellerTarif       = tarif
	self.aktuellerPreis       = self.fsobjekt.gib_Preis_von(tarif)
	self.eingeworfene_Muenze  =  ""
    	self.setze_zu_zahlende_Summe (self.aktuellerPreis)
   	self.anzeigeobjekt.setze_AnzeigeText ("zahlen",
   	   				wert=self.aktuellerPreis)

   def rueckzahlen (self,betrag):
    	if  betrag > 0.0:
    	   self.setze_Rueckgeld (self.geldobjekt.gib_Stueckelung(betrag))
   	   self.anzeigeobjekt.setze_AnzeigeText ("leeren",wert=betrag)
    	else:
    	   self.setze_Rueckgeld ([])

   def setze_eingeworfene_Muenze(self,muenze):
        self.eingeworfene_Muenze  =  muenze
   	wert     =  self.geldobjekt.gib_Wert_von (muenze)
   	self._vermindere_zu_zahlende_Summe (wert)
   	self._erhoehe_bezahlte_Summe (wert)
   	zzSumme  =  self.gib_zu_zahlende_Summe ()
   	if  zzSumme > 0.0:
   	   self.anzeigeobjekt.setze_AnzeigeText ("zahlen",wert=zzSumme)
   	else:
	   self.Fahrschein_entnommen =  "falsch"
   	   self.rueckzahlen (abs(zzSumme))
